SystemOrganization addCategory: #'tODE-Views'!

TOView subclass: #TOClassBrowser
	instanceVariableNames: 'classDefinition selectedSuperclass classTemplate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 00:06'!
actualClass

	self object isBehavior
		ifTrue: [ ^self object ].
	^super actualClass! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 19:04'!
classDefinition

	classDefinition ifNil: [ classDefinition := self classDefinitionTemplate: self classTemplate ].
	^ classDefinition! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 18:31'!
classDefinition: anObject
	classDefinition := anObject! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 00:08'!
classTemplate
	"#explorer, #definition, #subclass or #new"
	
	classTemplate ifNil: [ classTemplate := #explorer ].
	^classTemplate ! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:53'!
renderClassDefinitionOn: html main: main

	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: 80;
				rows: self classDefinition lineCount + 1;
				value: self classDefinition ;
				onKeyUpMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := false ])};
				onKeyDownMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := true ]).
					83 "s"-> (html jQuery ajax
					callback: [ :value | classDefinition := value .  ] value: (html jQuery id: id) value;
						script: [:s | 
							ctlKeyPressed 
								ifTrue: [
									"ctl-s"
									ctlKeyPressed := false]]).};
				callback: [ :value | classDefinition := value ];
				onChange: (scrpt html: [ :h | h render: self classDefinition ]) ] 
		on: html.
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 20:42'!
renderCommandLink: commandSelector label: label message: message on: html main: main
	| id |
	(html div)
		id: (id := html nextId);
		script:
				((html jQuery new dialog)
					html: message;
						title: 'Information';
						resizable: false;
						modal: true).
	self
		renderLink: [ :s | 
			| success result frame |
			success := true.
			[ 
			result := self
				perform: commandSelector
				withArguments: {s. id} ] on: TOAbortCommand do: [ :ex | success := false ].
			self properties
				at: 'result'
				put:
					{result.
					success}.
			success
				ifTrue: [ 
					frame := main currentSpace push: result.
					frame selectedCenterTab: #class.
					main updateCenterSideHistory: s ] ]
		with: [ html text: label ]
		on: html.
	html space! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 20:47'!
renderCommandsOn: html main: main

	self 
		renderCommandLink: #copyClass:id: label: 'Copy...' message: 'Copy... not implement' on: html main: main;
		renderCommandLink: #removeClass:id: label: 'Remove class...' message: 'Remove class... not implemented' on: html main: main;
		renderCommandLink: #renameClass:id: label: 'Rename...' message: 'Rename... not implemented' on: html main: main;
		yourself! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:55'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self classTemplate == #explorer
		ifTrue: [ self renderClassExplorerOn: html main: main ]
		ifFalse: [ self renderClassDefinitionOn: html main: main ]
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 20:58'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main
	self
		renderLink: [ :s | 
			classTemplate := definitionType.
			classDefinition := nil.
			main updateCenterSideHistory: s ]
		with: [ html text: label ]
		on: html.
	html space
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 00:23'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self classTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'explorer' on: html main: main ]
		ifFalse: [ html text: 'explorer'; space ].
	type ~~ #definition
		ifTrue: [ self renderDefinitionTypeChoiceLink: #definition label: 'Class definition' on: html main: main ]
		ifFalse: [ html text: 'Class definition'; space ].
	type ~~ #new
		ifTrue: [ self renderDefinitionTypeChoiceLink: #new label: 'New class template' on: html main: main ]
		ifFalse: [ html text: 'New class template'; space ].
	type ~~ #subclass
		ifTrue: [ self renderDefinitionTypeChoiceLink: #subclass label: 'Subclass template' on: html main: main ]
		ifFalse: [ html text: 'Subclass template'; space ].
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 18:44'!
renderSuperclassHeading: aClass on: html main: main
	html text: 'Superclasses: '.
	aClass allSuperclasses reversed
		do: [ :supClass | 
			supClass == selectedSuperclass
				ifTrue: [ html strong: supClass name ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							selectedSuperclass := supClass.
							classDefinition := nil.
							main updateCenterSideHistory: s ]
						with: [ html strong: supClass name ]
						on: html ].
			html text: '->' ].
	selectedSuperclass == nil
		ifTrue: [ html strong: aClass name ]
		ifFalse: [ 
			self
				renderLink: [ :s | 
					classDefinition := selectedSuperclass := nil.
					main updateCenterSideHistory: s ]
				with: [ html strong: aClass name ]
				on: html ]! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 18:45'!
theClass

	selectedSuperclass ifNil: [ ^self actualClass ].
	^selectedSuperclass ! !

TOView subclass: #TOInspector
	instanceVariableNames: 'basicInspect toggleVisible basicMembers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
basicFieldsFor: anObject

	(Pragma allNamed: #tODEBasicInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
fieldsFor: anObject

	(Pragma allNamed: #tODEInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 09:25'!
getMembers
	| members |
	basicMembers := toggleVisible := true.
	basicInspect
		ifTrue: [ members := self basicFieldsFor: self object ]
		ifFalse: [ 
			members := self fieldsFor: self object.
			members isEmpty
				ifTrue: [ 
					members := self basicFieldsFor: self object.
					toggleVisible := false ]
				ifFalse: [ basicMembers := false ] ].
	^ members! !

!TOInspector methodsFor: 'initialize-release' stamp: 'dkh 5/23/2011 09:25'!
initialize

	super initialize.
	basicInspect := toggleVisible := basicMembers := false.! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:40'!
renderBasicToggleOn: html main: main
	toggleVisible
		ifTrue: [
			self
				renderLink: [ :s | 
					basicInspect := basicInspect not.
					main updateCenterOn: s ]
				with: (basicInspect ifTrue: [ 'standard inspector' ] ifFalse: [ 'basic inspector'])
				on: html.
			html break ].
! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 21:06'!
renderContentOn: html main: main
	| members classText actualClass |
	members := self getMembers.
	actualClass := self actualClass.
	classText := self object isBehavior
		ifTrue: [ 'the Class ', actualClass name]
		ifFalse: ['an instance of ', actualClass name ].
	(html heading)
		level: 3;
		with:
				(basicMembers
						ifTrue: ['Basic Inspector on ', classText ]
						ifFalse: ['Inspector on ', classText ]).
	self renderMembers: members on: html main: main.
	html break.
	self renderBasicToggleOn: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:45'!
renderMembers: members on: html main: main
	members
		do: [ :assoc | 
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: assoc value.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: assoc key
				on: html.
			html text: ' -> ' , (assoc value printStringLimitedTo: 50).
			html break ]! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 18:26'!
renderClassTabOn: html frame: frame tOdeMain: main
	(frame properties 
		at: #classBrowser 
		ifAbsent: [ frame properties at: #classBrowser put: (TOClassBrowser new object: self) ])
			renderContentOn: html
			main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 16:43'!
renderHelpTabOn: html frame: frame tOdeMain: main
	self isBehavior
		ifTrue: [ 
			(html heading)
				level: 3;
				with: 'I am the Class ', self name.
			html preformatted: self comment ]
		ifFalse: [ 
			(html heading)
				level: 3;
				with: 'I am an instance of ', self class name.
			html preformatted: self class comment ]	! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:35'!
renderInspectorTabOn: html frame: frame tOdeMain: main
	(frame properties 
		at: #inspector 
		ifAbsent: [ frame properties at: #inspector put: (TOInspector new object: self) ])
			renderContentOn: html
			main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:34'!
renderMethodTabOn: html frame: frame tOdeMain: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/22/2011 12:25'!
tODEBasicInspectorFields
	<tODEBasicInspectorFields>
	| members |
	members := WriteStream on: Array new.
	self class allInstVarNames 
		keysAndValuesDo: [ :index :each | members nextPut: each -> (self instVarAt: index) ].
	self class isVariable
		ifTrue: [ 1 to: self basicSize do: [ :index | members nextPut: index -> (self basicAt: index) ] ].
	^ members contents! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEClassTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #classBrowser;
		receiver: self;
		label: 'class';
		order: 25;
		group: 'development';
		renderSelector: #renderClassTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEHelpTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #help;
		receiver: self;
		label: 'help';
		order: 25;
		group: 'basic';
		renderSelector: #renderHelpTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEInspectorTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #inspect;
		receiver: self;
		label: 'inspect';
		order: 50;
		group: 'basic';
		renderSelector: #renderInspectorTabOn:frame:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/23/2011 23:10'!
tODEMethodTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #methodBrowser;
		receiver: self;
		label: 'method';
		order: 50;
		group: 'development';
		renderSelector: #renderMethodTabOn:frame:tOdeMain:! !
